<?php
session_start();

/* If conversion is too long*/
ini_set('max_execution_time', 60);

/*
Script : IPB 2.1.6 to MyBB 1.1.5 Converter
Author : Fixazo (visit us at http://forum.feaks-forum.info and http://trichkreu.free.fr)
Creation date : Jul 1th 2006
Version : 1.0 final

----------------------------------------------------------

This beta isn't be able to convert these options :
- Admin and mod logs
- Admin permissions
- File attachments
- Ban filters (Not supported by MyBB)
- Forums permissions
- Multiples childs forums (Not definitive)
- Personnals poll's votes viewing (Not supported by IPB)
- Topics rating
*/
?>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr">
<head>
<title>IPB 2.1.6 to MyBB 1.1.5 Converter</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" href="./ipb2mybb.css" />
</head>
<body>
<div id="main">
<p id="logo"><img src="ipb.gif" alt="" title="IPB to MyBB converter" /> To <img src="mybb.gif" alt="" title="IPB to MyBB converter" /></p>

<h3>Welcome on the IPB 2.1.6 to MyBB 1.1.5 Converter !</h3>

<div id="trichkreu">
<?php 

/* Error Reporting */
error_reporting(E_ALL);

/* Errors definition */
$errors = array(
'mysqlFailure' => '<p style="color: red; font-weight: bold;">Can\'t connect to MySQL, please verify you entered correct informations.</p>',
'dbFailure' => '<p style="color: red; font-weight: bold;">Can\'t connect to the database, please verify you entered correct informations.</p>',
'empty' => '<p style="color: red; font-weight: bold;">Please fill all the required fields.</p>'
);

/* Messages definition */
$msg = array(
'mysql' => '<p style="color: green; font-weight: bold;">Congratulations, you were successfully connected to MySQL !</p>',
'db' => '<p style="color: green; font-weight: bold;">Congratulations, you were successfully connected to the database !</p>'
);


/* Replace HTML to BBcode (fucking IPB which stock HTML in db) */
function html2bbcode($text) {
	$postHtml = Array(
	'/<b>(.*?)<\/b>/si',
	'/<i>(.*?)<\/i>/si',
	'/<u>(.*?)<\/u>/si',
	'/<strike>(.*?)<\/strike>/si',
	'/<br \/>/si',
	'/<span style="color:(.*?)">(.*?)<\/span>/si',
	'/<a href="(.*?)" target="_blank">(.*?)<\/a>/si',
	'/<a href="mailto:(.*?)">(.*?)<\/a>/si',
	'/<img src="style_emoticons\/<#EMO_DIR#>\/(.*?)" style="vertical-align:middle" emoid="(.*?)" border="0" alt="(.*?)" \/>/si',
	'/<img src="(.*?)" border="0" alt="(.*?)" \/>/si',
	'/<div class=\'quotetop\'>QUOTE<\/div><div class=\'quotemain\'>(.*?)<\/div>/si',
	'/<!--(.*?)-->/si',
	'/<div class=\'codetop\'>CODE<\/div><div class=\'codemain\'>(.*?)<\/div>/si',
	'/<div align="(left|center|right)">(.*?)<\/div>/si',
	'/<ol type=\'1\'>(.*?)<\/ol>/si',
	'/<ul>(.*?)<\/ul>/si',
	'/<li>(.*?)<\/li>/si',
	'/<span style="font-size:(.*?)pt;line-height:(.*?)%">(.*?)<\/span>/si',
	'/<span style="font-family:(.*?)">(.*?)<\/span>/si',
	'/<div class=\'quotetop\'>QUOTE(.*?) [snapback](.*?)[\/snapback]<\/div><div class=\'quotemain\'>(.*?)<\/div>/si', // This regexp doesn't work
	);

	$postBBCode = Array(
	'[b]$1[/b]',
	'[i]$1[/i]',
	'[u]$1[/u]',
	'[strike]$1[/strike]',
	"\n",
	'[color=$1]$2[/color]',
	'[url=$1]$2[/url]',
	'[email=$1]$2[/email]',
	'$2',
	'[img]$1[/img]',
	'[quote]$1[/quote]',
	'',
	'[code]$1[/code]',
	'[align=$1]$2[/align]',
	'[list=1]$1[/list]',
	'[list]$1[/list]',
	'[*]$1',
	'$3',
	'[font=$1]$2[/font]',
	'[quote name=$1]$3[/quote]',
	);

	$text = preg_replace($postHtml, $postBBCode, $text);

	$htmlentities = array(
	'&amp;',
	'&quote;',
	'&gt;',
	'&lt;'
	);

	$htmlreplace = array(
	'&',
	'"',
	'>',
	'<'
	);

	$text = str_replace($htmlentities, $htmlreplace, $text);



	return $text;
}


if (empty($_SERVER['QUERY_STRING']))
{
	?>
		<div id="notice">
		<p>To proceed, you have to give us your database authentication details :</p>
		<p><span style="color: red;">Note :</span> If you are using free.fr for webhosting, please create a directory called "sessions" on your ftp root, otherwise it'll not work.</p>
		
		<form action="index.php?part=1" method="post">
		<table>
			<tr>
				<td>Database Host :</td> <td><input type="text" name="host" /></td>
			</tr>
			<tr>
				<td>Database Username :</td> <td><input type="text" name="username" /></td>
			</tr>
			<tr>
				<td>Database Password :</td> <td><input type="text" name="password" /></td>
			</tr>
			<tr>
				<td>Database Name :</td> <td><input type="text" name="name" /></td>
			</tr>
			<tr>
				<td>IPB Tables Prefix :</td> <td><input type="text" name="ipbprefix" /></td>
			</tr>
			<tr>
				<td>MyBB Tables prefix :</td> <td><input type="text" name="mybbprefix" /></td>
			</tr>
			<tr>
				<td></td><td><input type="submit" name="dbInfs" value="Next &gt;&gt;" /></td>
			</tr>
		</table>
		</form>
		</div>
<?php		
}
elseif ($_GET['part'] == 1)
{
	/* If database informations have been sent */
	if (isset($_POST['dbInfs']))
	{
		/* If required informations are not empty */
		if (!empty($_POST['host']) && !empty($_POST['username']) && !empty($_POST['name']) && !empty($_POST['ipbprefix']) && !empty($_POST['mybbprefix']))
		{
			foreach ($_POST as $key => $val)
			{
				$_SESSION[$key] = $val;
			}

			$MySQL = @mysql_connect($_POST['host'], $_POST['username'], $_POST['password']) or die(false);
			$db = @mysql_select_db($_POST['name'], $MySQL) or die(false);

			/* Connection to the database */
			if (!$MySQL) {
				echo $errors['mysqlFailure'];
				echo '<p><b><a href="javascript:history.go(-1);" title="Previous Page">&lt;&lt; Previous Page</a></b></p>';
			}
			else {
				mysql_connect($_POST['host'], $_POST['username'], $_POST['password']);
				echo $msg['mysql'];
				if (!$db) {
					echo $errors['dbFailure'];
					echo '<p><b><a href="javascript:history.go(-1);" title="Previous Page">&lt;&lt; Previous Page</a></b></p>';
				}
				else {
					echo $msg['db'];
					mysql_select_db($_POST['name']);
					echo '<p><b><a href="index.php?part=2" title="Next Page">Next Page &gt;&gt;</a></b></p>';
				}
			}
		}
		else {
			echo $errors['empty'];
			echo '<p><b><a href="javascript:history.go(-1);" title="Previous Page">&lt;&lt; Previous Page</a></b></p>';
		}
	}
}
elseif ($_GET['part'] == 2)
{
	mysql_connect($_SESSION['host'], $_SESSION['username'], $_SESSION['password']);
	mysql_select_db($_SESSION['name']);
	
	echo '<h3>Congratulations ! You\'ve finished your board conversion with success !</h3>'.
	'<div id="notice"><p>This converter is actually a beta version, so after your conversion, you may not see your forums on the Mybboard index. To fix this problem, login to Admin control panel and add a new forum anywhere. Refresh the board index and normally you\'ll see your old forums :). Then you can delete the last forum you created.</p>
		 <p style="color: red;">If you can\'t connect to the ACP, try to delete the cookies for this domain.</p></div>';
	
	
	/* Posts conversion */
	$sqlCountPosts = mysql_query('SELECT COUNT(pid) AS nbPosts FROM ibf_posts') or die(mysql_error());
	$countPosts = mysql_fetch_array($sqlCountPosts);
	
	$_SESSION['nbPosts'] = $countPosts['nbPosts'];
	mysql_query('TRUNCATE TABLE mybb_posts') or die(mysql_error());

	if ($countPosts['nbPosts'] <= 5000)
	{

		$sqlPosts = mysql_query('SELECT p.*, t.forum_id, m.id AS edituid FROM ibf_posts p LEFT JOIN ibf_topics t ON p.topic_id=t.tid LEFT JOIN ibf_members m ON p.edit_name=m.name') or die(mysql_error());

		$i = 0;
		while ($posts = mysql_fetch_array($sqlPosts))
		{
			$useSign = ($posts['use_sig'] == 1) ? 'yes' : 'no';
			$useEmo = ($posts['use_emo'] == 1) ? 'no' : 'yes';

			mysql_query("INSERT INTO mybb_posts VALUES('".$posts['pid']."', '".$posts['topic_id']."', '".$posts['post_parent']."', '".$posts['forum_id']."', '', '".$posts['icon_id']."', '".$posts['author_id']."', '".addslashes($posts['author_name'])."', '".$posts['post_date']."', '".addslashes(html2bbcode($posts['post']))."', '".$posts['ip_address']."', '".$useSign."', '".$useEmo."', '".$posts['edituid']."', '".$posts['edit_time']."', 1)") or die(mysql_error());

			$i++;
		}

		echo '<p class="message"><b>Posts : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';
	}
	else echo '<p class="badmessage"><b>Posts : <span style="color: red;">Not converted</span></b> | Your board has more than 5000 posts ('.$countPosts['nbPosts'].' posts exactly). To convert posts <a href="index.php?part=3&amp;begin=0" title="Convert posts">Click here</a></p>';

	/* End of posts conversion */

	/* Announcements conversion */
	$sqlAnnouncements = mysql_query('SELECT * FROM ibf_announcements') or die(mysql_error());
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_announcements') or die(mysql_error());
	while ($announcements = mysql_fetch_array($sqlAnnouncements))
	{
		mysql_query("INSERT INTO mybb_announcements VALUES('".$announcements['announce_id']."', '".$announcements['announce_forum']."', '".$announcements['announce_member_id']."', '".addslashes($announcements['announce_title'])."', '".addslashes($announcements['announce_post'])."', '".$announcements['announce_start']."', '".$announcements['announce_end']."', '".$announcements['announce_html_enabled']."', 'yes', 'yes')") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Announcements : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of announcements conversion */




	/* BadWords conversion */
	$sqlBadwords = mysql_query('SELECT * FROM ibf_badwords') or die(mysql_error());
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_badwords') or die(mysql_error());
	while ($badwords = mysql_fetch_array($sqlBadwords))
	{
		mysql_query("INSERT INTO mybb_badwords VALUES('".$badwords['wid']."', '".addslashes($badwords['type'])."', '".addslashes($badwords['swop'])."')") or die(mysql_error());
		$i++;
	}

	echo '<p class="message"><b>Badwords : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';
	/* End of badwords conversion */




	/* Calendar events conversion */

	$sqlEvents = mysql_query('SELECT * FROM ibf_cal_events') or die(mysql_error());
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_events') or die(mysql_error());
	while ($events = mysql_fetch_array($sqlEvents))
	{

		mysql_query("INSERT INTO mybb_events VALUES('".$events['event_id']."', '".addslashes($events['event_title'])."', '".$events['event_member_id']."', '".date('d-m-Y', $events['event_unix_from'])."', '".addslashes($events['event_content'])."', '".$events['event_private']."')") or die(mysql_error());
		$i++;
	}

	echo '<p class="message"><b>Calendar events : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of calendar events conversion */



	/* Forums conversion */
	$sqlForums = mysql_query('SELECT * FROM ibf_forums') or die(mysql_error());
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_forums') or die(mysql_error());
	while ($forums = mysql_fetch_array($sqlForums))
	{
		if ($forums['parent_id'] == -1)
		{
			$type = 'c';
			$parentlist = $forums['id'];
		}
		else
		{
			$type = 'f';
			$parentlist = $forums['parent_id'].','.$forums['id'];
		}

		/* If the forum is closed */
		if ($forums['status'] == 0)
		$isOpen = 'no';
		else $isOpen = 'yes';

		if ($forums['use_html'] == 1)
		$useHtml = 'yes';
		else $useHtml = 'no';

		if ($forums['use_ibc'] == 1)
		$useMyCode = 'yes';
		else $useMyCode = 'no';

		if ($forums['inc_postcount'] == 1)
		$usePostCount = 'yes';
		else $usePostCount = 'false';

		mysql_query("INSERT INTO mybb_forums VALUES('".$forums['id']."', '".addslashes($forums['name'])."', '".addslashes($forums['description'])."', '".$forums['redirect_url']."', '".$type."', '".$forums['parent_id']."', '".$parentlist."', '1', 'yes', '".$isOpen."', '".$forums['topics']."', '".$forums['posts']."', '".$forums['last_post']."', '".addslashes($forums['last_poster_name'])."', '".$forums['last_id']."', '".$useHtml."', '".$useMyCode."', 'yes', 'yes', 'yes', 'yes', '1', '".$usePostCount."', '".$forums['password']."', 'yes', 'no', 'no', 'no', 0, 'no', '', '".addslashes($forums['rules_title'])."', '".addslashes($forums['rules_text'])."')") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Forums : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of forums conversion (it wasn't easy :p) */




	/* Moderators conversion */

	$sqlModos = mysql_query('SELECT * FROM ibf_moderators') or die(mysql_error());
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_moderators') or die(mysql_error());

	while ($modos = mysql_fetch_array($sqlModos))
	{
		$editPosts = ($modos['edit_post'] == 1) ? 'yes' : 'no';
		$deletePosts = ($modos['delete_post'] == 1) ? 'yes' : 'no';
		$viewIps = ($modos['view_ip'] == 1) ? 'yes' : 'no';
		$openTopics = ($modos['open_topic'] == 1) ? 'yes' : 'no';
		$editTopics = ($modos['edit_topic'] == 1) ? 'yes' : 'no';


		mysql_query("INSERT INTO mybb_moderators VALUES('".$modos['mid']."', '".$modos['forum_id']."', '".$modos['member_id']."', '".$editPosts."', '".$deletePosts."', '".$viewIps."', '".$openTopics."', '".$editTopics."')") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Moderators : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of moderators conversion */



	/* Topics conversion */
	$sqlTopics = mysql_query('SELECT * FROM ibf_topics') or die(mysql_error());

	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_threads') or die(mysql_error());
	while ($topics = mysql_fetch_array($sqlTopics))
	{
		$closed = ($topics['state'] == 'closed') ? 'yes' : 'no';

		mysql_query("INSERT INTO mybb_threads VALUES('".$topics['tid']."', '".$topics['forum_id']."', '".addslashes(html2bbcode($topics['title']))."', '".$topics['icon_id']."', '".$topics['poll_state']."', '".$topics['starter_id']."', '".addslashes($topics['starter_name'])."', '".$topics['start_date']."', '".$topics['topic_firstpost']."', '".$topics['last_post']."', '".addslashes($topics['last_poster_name'])."', '".$topics['views']."', '".$topics['posts']."', '".$closed."', '".$topics['pinned']."', 0, 0, '', 1)") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Topics : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';
	/* End of topics conversion */





	/* Polls conversion */
	$sqlPolls = mysql_query('SELECT * FROM ibf_polls') or die(mysql_error());

	$i = 0;
	$stringChoices = '';
	$stringVotes = '';
	mysql_query('TRUNCATE TABLE mybb_polls') or die(mysql_error());
	while ($polls = mysql_fetch_array($sqlPolls))
	{
		$array = unserialize(stripslashes($polls['choices'])); // Serialized string to array

		for ($j = 1; $j <= sizeof($array[1]['choice']); $j++) // Poll's choices conversion
		{
			$stringChoices .= $array[1]['choice'][$j].'||~|~||';
		}

		for ($k = 1; $k <= sizeof($array[1]['votes']); $k++) // Poll's votes conversion
		{
			$stringVotes .= $array[1]['votes'][$k].'||~|~||';
		}

		mysql_query("INSERT INTO mybb_polls VALUES('".$polls['pid']."', '".$polls['tid']."', '".addslashes($array[1]['question'])."', '".$polls['start_date']."', '".addslashes($stringChoices)."', '".$stringVotes."', '".sizeof($array[1]['choice'])."', '".$polls['votes']."', 0, 'no', 'no', 'no')") or die(mysql_error());


		$i++;
	}

	echo '<p class="message"><b>Polls : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of polls conversion */




	/* Polls voters conversion */

	$sqlVoters = mysql_query('SELECT ibf_voters.*,ibf_polls.pid AS poll_id FROM ibf_voters LEFT JOIN ibf_polls ON ibf_voters.tid=ibf_polls.tid') or die(mysql_error());

	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_pollvotes');

	while ($voters = mysql_fetch_array($sqlVoters))
	{
		mysql_query("INSERT INTO mybb_pollvotes VALUES('".$voters['vid']."', '".$voters['poll_id']."', '".$voters['member_id']."', '1', '".$voters['vote_date']."')") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Poll\'s voters : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of polls voters conversion */


	/* Users conversion */


	function random_str($length="8")
	{
		$set = array("a","A","b","B","c","C","d","D","e","E","f","F","g","G","h","H","i","I","j","J","k","K","l","L","m","M","n","N","o","O","p","P","q","Q","r","R","s","S","t","T","u","U","v","V","w","W","x","X","y","Y","z","Z","1","2","3","4","5","6","7","8","9");
		$str = '';
		for($i=1;$i<=$length;$i++)
		{
			$ch = rand(0, count($set)-1);
			$str .= $set[$ch];
		}
		return $str;
	}


	$sqlUsers = mysql_query('SELECT m.*, mc.*, me.*, me.id AS me_id FROM ibf_members m LEFT JOIN ibf_members_converge mc ON mc.converge_id=m.id LEFT JOIN ibf_member_extra me ON me.id=m.id') or die(mysql_error());

	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_users') or die(mysql_error());

	while ($users = mysql_fetch_array($sqlUsers))
	{
		if (!empty($users['bday_day']) && !empty($users['bday_month']) && !empty($users['bday_year']))
		$bday = $users['bday_day'].'-'.$users['bday_month'].'-'.$users['bday_year'];
		else $bday = '';

		$emailNotify = ($users['email_pm'] == 1) ? 'yes' : 'no';
		$receivePms = ($users['members_disable_pm'] == 1) ? 'no' : 'yes';
		$showPopup = ($users['show_popup'] == 1) ? 'yes' : 'no';
		$viewSigs = ($users['view_sigs'] == 1) ? 'yes' : 'no';
		$viewAvs = ($users['view_avs'] == 1) ? 'yes' : 'no';
		$dst = ($users['dst_in_use'] == 1) ? 'yes' : 'no';




		mysql_query("INSERT INTO mybb_users VALUES('".$users['id']."', '".addslashes($users['name'])."', '".$users['converge_pass_hash']."', '".addslashes($users['converge_pass_salt'])."', '".random_str(50)
		."', '".addslashes($users['converge_email'])."', '".$users['posts']."', '".$users['avatar_location']."', 0, '".$users['mgroup']."', '', 0, '".addslashes($users['title'])."', '".$users['joined']."', '".$users['last_activity']."', '".$users['last_visit']."', '".$users['last_post']."',' ".addslashes($users['website'])."', '".$users['icq_number']."', '".addslashes($users['aim_name'])."',' ".addslashes($users['yahoo'])."', '".addslashes($users['msnname'])."', '".$bday."', '".addslashes(html2bbcode($users['signature']))."', 'yes', '".$users['hide_email']."', '".$emailNotify."', 'no', '".$receivePms."', '".$showPopup."', 'yes', 'yes', '', '".$viewSigs."', '".$viewAvs."', 'yes', 0, 0, 0, '', '', 0, '".$dst."', '', '".$users['ignored_users']."', 0, 'no', 0, '', '', '', '".$users['notes']."', '', 0, 0, '".$users['ip_address']."', '', 0, 0)") or die(mysql_error());

		$i++;
	}

	echo '<p class="message"><b>Users : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';

	/* End of users conversion */



	/* Emoticons conversion */

	$sqlSmiles = mysql_query('SELECT * FROM ibf_emoticons') or die(mysql_error());

	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_smilies') or die(mysql_error());

	while ($smiles = mysql_fetch_array($sqlSmiles))
	{
		$clickable = ($smiles['clickable'] == 1) ? 'yes' : 'no';
		$path = 'images/smilies/';

		mysql_query("INSERT INTO mybb_smilies VALUES('".$smiles['id']."', '".addslashes($smiles['typed'])."', '".addslashes($smiles['typed'])."', '".$path.$smiles['image']."', '".$i."', '".$clickable."')") or die(mysql_error());

		$i++;
	}
	
	echo '<p class="message"><b>Emoticons : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b><br />
<span style="font-size: 9px;">Move your IPB\'s emoticons (#IPB_DIR#/style_emoticons/default/) to MyBB smilies directory (#MYBB_DIR#/images/smilies/)</span></p>';

	/* End of emoticons conversion */
	
	
	/* Groups conversion */
	$sqlGroups = mysql_query('SELECT * FROM ibf_groups') or die(mysql_error());
	
	$i = 0;
	mysql_query('TRUNCATE TABLE mybb_usergroups') or die(mysql_error());
	
	while ($groups = mysql_fetch_array($sqlGroups))
	{
		$namestyle = $groups['prefix'].'{username}'.$groups['suffix'];
		$isBanned = ($groups['g_view_board'] == 0) ? 'yes' : 'no';
		$canView = ($groups['g_view_board'] == 1) ? 'yes' : 'no';
		$dlAttachments = ($groups['g_can_msg_attach'] == 1) ? 'yes' : 'no';
		$postThreads = ($groups['g_post_new_topics'] == 1) ? 'yes' : 'no';
		$postReply = ($groups['g_reply_own_topics'] == 1) ? 'yes' : 'no';
		$editPosts = ($groups['g_edit_posts'] == 1) ? 'yes' : 'no';
		$deletePosts = ($groups['g_delete_own_posts'] == 1) ? 'yes' : 'no';
		$deleteTopics = ($groups['g_delete_own_topics'] == 1) ? 'yes' : 'no';
		$postPolls = ($groups['g_post_polls'] == 1) ? 'yes' : 'no';
		$votePolls = ($groups['g_vote_polls'] == 1) ? 'yes' : 'no';
		$usePm = ($groups['g_use_pm'] == 1) ? 'yes' : 'no';
		$sendEmail = ($groups['g_email_friend'] == 1) ? 'yes' : 'no';
		$calPost = ($groups['g_calendar_post'] == 1) ? 'yes' : 'no';
		$cp = ($groups['g_access_cp'] == 1) ? 'yes' : 'no';
		$supMod = ($groups['g_is_supmod'] == 1) ? 'yes' : 'no';
		$userCp = ($groups['g_title'] != 'Guests' || $groups['g_title'] != 'Banned') ? 'yes' : 'no';
		$upAvs = ($groups['g_avatar_upload'] == 1) ? 'yes' : 'no';

		mysql_query("INSERT INTO mybb_usergroups VALUES('".$groups['g_id']."', 1, '".$groups['g_title']."', '', '".$namestyle."', '".$groups['g_title']."', 0, '', '', '".$isBanned."', '".$canView."', 'yes', '".$dlAttachments."', '".$postThreads."', '".$postReply."', '".$dlAttachments."', 'no', '".$editPosts."', '".$deletePosts."', '".$deleteTopics."', 'no', '".$postPolls."', '".$votePolls."', '".$usePm."', '".$usePm."', '".$usePm."', 'no', '".$groups['g_max_messages']."', '".$sendEmail."', '".$canView."', '".$canView."', '".$calPost."', '".$calPost."', '".$canView."', '".$canView."', '".$canView."', '".$cp."', '".$supMod."', 'yes', '".$userCp."', '".$upAvs."', 'no', 'no', '".$canView."', 'no', 'no', 5, 0, 'yes', 0, 'no')") or die(mysql_error());
		
		$i++;
	}
	
	echo '<p class="message"><b>Groups : <span style="color: green;">Done</span></b> | Inserted rows : <b>'.$i.'</b></p>';
	
	/* End of groups conversion */
}
elseif ($_GET['part'] == 3)
{
	mysql_connect($_SESSION['host'], $_SESSION['username'], $_SESSION['password']);
	mysql_select_db($_SESSION['name']);
	
	if ($_SESSION['nbPosts'] > 10000)
	{
		$done = $_GET['begin'];
		echo '<h3>Posts conversion</h3>';
		
		if (is_numeric($done))
		{
			if ($done <= $_SESSION['nbPosts'])
			{
				echo '<div id="notice">You\'re going to insert 10,000 entries in your database, it could be take a few minutes, so don\'t try to stop the script or refresh, otherwise that could obstruct conversion.</div>';
				$end = $_GET['begin']+10000;
				$where = ' WHERE p.pid BETWEEN '.$_GET['begin'].' AND '.$end;	
		
				$sqlPosts = mysql_query('SELECT p.*, t.forum_id, m.id AS edituid FROM ibf_posts p LEFT JOIN ibf_topics t ON p.topic_id=t.tid LEFT JOIN ibf_members m ON p.edit_name=m.name'.$where) or die(mysql_error());
		
				$i = 0;
				while ($posts = mysql_fetch_array($sqlPosts))
				{
					$useSign = ($posts['use_sig'] == 1) ? 'yes' : 'no';
					$useEmo = ($posts['use_emo'] == 1) ? 'no' : 'yes';
		
					mysql_query("INSERT INTO mybb_posts VALUES('".$posts['pid']."', '".$posts['topic_id']."', '".$posts['post_parent']."', '".$posts['forum_id']."', '', '".$posts['icon_id']."', '".$posts['author_id']."', '".addslashes($posts['author_name'])."', '".$posts['post_date']."', '".addslashes(html2bbcode($posts['post']))."', '".$posts['ip_address']."', '".$useSign."', '".$useEmo."', '".$posts['edituid']."', '".$posts['edit_time']."', 1)") or die(mysql_error());
		
					$i++;
				}
				
				$done += 10000;
		
				echo '<p class="message"><b>Posts : <span style="color: green;">Done (from '.$_GET['begin'].' to '.$end.')</span></b> | Inserted rows : <b>'.$i.'</b> | <a href="index.php?part=3&amp;begin='.$done.'" title="convert next posts">Convert next posts</a></p>';
			}
			else echo '<div id="notice">Congratulations !! All your posts were converted with success.';
		}
		else echo '<p class="badmessage">TrichKreu</p>';
	}
	else echo '<p class="badmessage">Your board contains less than 10,000 posts !!</p';
}
?>
</div>
</div>
<p id="copyright">&copy; Fixazo 2006 - 1.0 final - <a href="http://trichkreu.free.fr" title="TrichKreu">TrichKreu</a></p>
</body>
</html>